org.apache.commons.collections4.map

## Class TransformedSortedMap<K,V>

- java.lang.Object
- - org.apache.commons.collections4.map.AbstractIterableMap<K,V>
  - - org.apache.commons.collections4.map.AbstractMapDecorator<K,V>
    - - org.apache.commons.collections4.map.TransformedMap<K,V>
      - - org.apache.commons.collections4.map.TransformedSortedMap<K,V>

- Type Parameters:
    `K` - the type of the keys in this map
    `V` - the type of the values in this map
  All Implemented Interfaces:
    Serializable, Map<K,V>, SortedMap<K,V>, Get<K,V>, IterableGet<K,V>, IterableMap<K,V>, Put<K,V>

      public class TransformedSortedMap<K,V>
      extends TransformedMap<K,V>
      implements SortedMap<K,V>

  Decorates another `SortedMap` to transform objects that are added.

  The Map put methods and Map.Entry setValue method are affected by this class. Thus objects must be removed or searched for using their transformed form. For example, if the transformation converts Strings to Integers, you must use the Integer form to remove objects.

  Note that TransformedSortedMap is not synchronized and is not thread-safe. If you wish to use this map from multiple threads concurrently, you must use appropriate synchronization. The simplest approach is to wrap this map using `Collections.synchronizedSortedMap(java.util.SortedMap<K, V>)`. This class may throw exceptions when accessed by concurrent threads without synchronization.

  This class is Serializable from Commons Collections 3.1.

  Since:
    3.0
  See Also:
    Serialized Form

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from interface java.util.Map

      `Map.Entry<K,V>`

  - ### Field Summary

    - ### Fields inherited from class org.apache.commons.collections4.map.TransformedMap

      `keyTransformer, valueTransformer`

  - ### Constructor Summary

    Constructors
    Modifier | Constructor and Description
    --- | ---
    `protected` | `TransformedSortedMap(SortedMap<K,V> map, Transformer<? super K,? extends K> keyTransformer, Transformer<? super V,? extends V> valueTransformer)` Constructor that wraps (not copies).

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `Comparator<? super K>` | `comparator()`
    `Set<Map.Entry<K,V>>` | `entrySet()`
    `K` | `firstKey()`
    `protected SortedMap<K,V>` | `getSortedMap()` Gets the map being decorated.
    `SortedMap<K,V>` | `headMap(K toKey)`
    `K` | `lastKey()`
    `SortedMap<K,V>` | `subMap(K fromKey, K toKey)`
    `SortedMap<K,V>` | `tailMap(K fromKey)`
    `static <K,V> TransformedSortedMap<K,V>` | `transformedSortedMap(SortedMap<K,V> map, Transformer<? super K,? extends K> keyTransformer, Transformer<? super V,? extends V> valueTransformer)` Factory method to create a transforming sorted map that will transform existing contents of the specified map.
    `static <K,V> TransformedSortedMap<K,V>` | `transformingSortedMap(SortedMap<K,V> map, Transformer<? super K,? extends K> keyTransformer, Transformer<? super V,? extends V> valueTransformer)` Factory method to create a transforming sorted map.

    - ### Methods inherited from class org.apache.commons.collections4.map.TransformedMap

      `checkSetValue, isSetValueChecking, put, putAll, transformedMap, transformingMap, transformKey, transformMap, transformValue`

    - ### Methods inherited from class org.apache.commons.collections4.map.AbstractMapDecorator

      `clear, containsKey, containsValue, decorated, equals, get, hashCode, isEmpty, keySet, remove, size, toString, values`

    - ### Methods inherited from class org.apache.commons.collections4.map.AbstractIterableMap

      `mapIterator`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface java.util.SortedMap

      `entrySet, keySet, values`

    - ### Methods inherited from interface java.util.Map

      `clear, compute, computeIfAbsent, computeIfPresent, containsKey, containsValue, equals, forEach, get, getOrDefault, hashCode, isEmpty, merge, put, putAll, putIfAbsent, remove, remove, replace, replace, replaceAll, size`

- - ### Constructor Detail

    - #### TransformedSortedMap

          protected TransformedSortedMap(SortedMap<K,V> map,
                                         Transformer<? super K,? extends K> keyTransformer,
                                         Transformer<? super V,? extends V> valueTransformer)

      Constructor that wraps (not copies).

      If there are any elements already in the collection being decorated, they are NOT transformed.

      Parameters:
        `map` - the map to decorate, must not be null
        `keyTransformer` - the predicate to validate the keys, null means no transformation
        `valueTransformer` - the predicate to validate to values, null means no transformation
      Throws:
        `NullPointerException` - if the map is null

  - ### Method Detail

    - #### transformingSortedMap

          public static <K,V> TransformedSortedMap<K,V> transformingSortedMap(SortedMap<K,V> map,
                                                                              Transformer<? super K,? extends K> keyTransformer,
                                                                              Transformer<? super V,? extends V> valueTransformer)

      Factory method to create a transforming sorted map.

      If there are any elements already in the map being decorated, they are NOT transformed. Contrast this with `transformedSortedMap(SortedMap, Transformer, Transformer)`.

      Type Parameters:
        `K` - the key type
        `V` - the value type
      Parameters:
        `map` - the map to decorate, must not be null
        `keyTransformer` - the predicate to validate the keys, null means no transformation
        `valueTransformer` - the predicate to validate to values, null means no transformation
      Returns:
        a new transformed sorted map
      Throws:
        `NullPointerException` - if the map is null
      Since:
        4.0

    - #### transformedSortedMap

          public static <K,V> TransformedSortedMap<K,V> transformedSortedMap(SortedMap<K,V> map,
                                                                             Transformer<? super K,? extends K> keyTransformer,
                                                                             Transformer<? super V,? extends V> valueTransformer)

      Factory method to create a transforming sorted map that will transform existing contents of the specified map.

      If there are any elements already in the map being decorated, they will be transformed by this method. Contrast this with `transformingSortedMap(SortedMap, Transformer, Transformer)`.

      Type Parameters:
        `K` - the key type
        `V` - the value type
      Parameters:
        `map` - the map to decorate, must not be null
        `keyTransformer` - the transformer to use for key conversion, null means no transformation
        `valueTransformer` - the transformer to use for value conversion, null means no transformation
      Returns:
        a new transformed sorted map
      Throws:
        `NullPointerException` - if map is null
      Since:
        4.0

    - #### getSortedMap

          protected SortedMap<K,V> getSortedMap()

      Gets the map being decorated.
      Returns:
        the decorated map

    - #### firstKey

          public K firstKey()

      Specified by:
        `firstKey` in interface `SortedMap<K,V>`

    - #### lastKey

          public K lastKey()

      Specified by:
        `lastKey` in interface `SortedMap<K,V>`

    - #### comparator

          public Comparator<? super K> comparator()

      Specified by:
        `comparator` in interface `SortedMap<K,V>`

    - #### subMap

          public SortedMap<K,V> subMap(K fromKey,
                                       K toKey)

      Specified by:
        `subMap` in interface `SortedMap<K,V>`

    - #### headMap

          public SortedMap<K,V> headMap(K toKey)

      Specified by:
        `headMap` in interface `SortedMap<K,V>`

    - #### tailMap

          public SortedMap<K,V> tailMap(K fromKey)

      Specified by:
        `tailMap` in interface `SortedMap<K,V>`

    - #### entrySet

          public Set<Map.Entry<K,V>> entrySet()

      Specified by:
        `entrySet` in interface `Map<K,V>`
      Specified by:
        `entrySet` in interface `Get<K,V>`
      Overrides:
        `entrySet` in class `AbstractMapDecorator<K,V>`
      Returns:
        a set view of the mappings contained in this map
      See Also:
        `Map.entrySet()`

Copyright © 2001–2019 The Apache Software Foundation. All rights reserved.